/******************************************************************************/
#include <stdio.h>
#include <math.h>
/******************************************************************************/
#define CHAN_TYPE 3
#define CHAN_SIZE 20
#define DENOM_LEN 3
#define ZERO 0
/******************************************************************************/
FILE *fp;
/******************************************************************************/
main()
{
 Open_Files();
 if(CHAN_TYPE == 3)
  Get_Type3_Chan();
}
/******************************************************************************/
/*                        Open files for writing.
*******************************************************************************/
int Open_Files()
{
 if(CHAN_TYPE == 3)
  fp=fopen("tc5cdata/chan3.dat","w");
 else if(CHAN_TYPE == 4)
  fp=fopen("tc5cdata/chan4.dat","w");
 return(0);
}
/******************************************************************************/
/*                         Get the type 3 channel.
*******************************************************************************/
int Get_Type3_Chan()
{
 int cnt,cnt1;
 double coeff,ip,op[DENOM_LEN];
 coeff=0.7;
 ip=1.0;
 for(cnt=ZERO;cnt<DENOM_LEN;cnt++)
  op[cnt]=0.0;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
 {
  op[0]=ip+2.0*coeff*op[1]-coeff*coeff*op[2];
  ip=0.0;
  fprintf(fp,"%14.10lf %14.10lf\n",op[0],op[0]);
  for(cnt1=DENOM_LEN-1;cnt1>ZERO;cnt1--)
   op[cnt1]=op[cnt1-1];
 }
 return(0);
}
/******************************************************************************/
