
/*          Compute the extrinsic information for "time" for decoder 1.
*******************************************************************************/
int Compute_Ge_Dec1(time)
int time;
{
 int bit,act_parity;
 double x,sym,parity;
 double erand48();
 if(Gamma_E_P1[time][ZERO] > Gamma_E_P1[time][ONE])
  parity =  1.0;
 else
  parity = -1.0;
// act_parity=Parity1[time];
// parity=Bit_Map[act_parity];;
 N3_Val[URADIUS]=erand48(N5_Store);
 N3_Val[UTHETA]=erand48(N6_Store);
 My_Gauss(VARIANCE,N3_Val);
 Add_Rx_Noise(parity);
// if(parity > FRAC_ZERO)
//  N3_Val[GRAND_0]= -N3_Val[GRAND_0];
// parity=parity-parity*N3_Val[GRAND_0];
 parity=parity+N3_Val[GRAND_0];
 for(bit=ZERO;bit<NUM_INPUTS;bit++)
 {
  sym=Bit_Map[bit];
  x=parity-sym;
  x= -x*x*Inv_Twice_Noise_Var;
  Gamma_E_P1[time][bit]=exp(x);
 }
 return(0);
}
/******************************************************************************/
/*         Modify the extrinsic information for "time" in decoder 1.
*******************************************************************************/
int Modify_Ge_Dec1(time)
int time;
{
 double sum,term;
 sum=Gamma_E_P1[time][ZERO]+Gamma_E_P1[time][ONE];
 Gamma_E_P1[time][ZERO]=Gamma_E_P1[time][ZERO]/sum;
 Gamma_E_P1[time][ONE]=Gamma_E_P1[time][ONE]/sum;
 if(Gamma_E_P1[time][ZERO] > Gamma_E_P1[time][ONE])
 {
  term= -2.0*VARIANCE*log(Gamma_E_P1[time][ZERO]);
  term=  sqrt(term)+2.0;
  term= -term*term*Inv_Twice_Noise_Var;
  Gamma_E_P1[time][ONE]=exp(term);
 }
 else
 {
  term= -2.0*VARIANCE*log(Gamma_E_P1[time][ONE]);
  term=  sqrt(term)-2.0;
  term= -term*term*Inv_Twice_Noise_Var;
  Gamma_E_P1[time][ZERO]=exp(term);
 }
 return(0);
}
/******************************************************************************/
/*          Compute the extrinsic information for "time" for decoder 2.
*******************************************************************************/
int Compute_Ge_Dec2(time)
int time;
{
 int bit,act_parity;
 double x,sym,parity;
 double erand48();
 if(Gamma_E_P2[time][ZERO] > Gamma_E_P2[time][ONE])
  parity=  1.0;
 else
  parity= -1.0;
// act_parity=Parity2[time];
// parity=Bit_Map[act_parity];
 N3_Val[URADIUS]=erand48(N5_Store);
 N3_Val[UTHETA]=erand48(N6_Store);
 My_Gauss(VARIANCE,N3_Val);
 Add_Rx_Noise(parity);
// if(N3_Val[GRAND_0] < FRAC_ZERO)
//  N3_Val[GRAND_0]= -N3_Val[GRAND_0];
// parity=parity-parity*N3_Val[GRAND_0];
 parity=parity+N3_Val[GRAND_0];
 for(bit=ZERO;bit<NUM_INPUTS;bit++)
 {
  sym=Bit_Map[bit];
  x=parity-sym;
  x= -x*x*Inv_Twice_Noise_Var;
  Gamma_E_P2[time][bit]=exp(x);
 }
 return(0);
}
/******************************************************************************/
/*         Modify the extrinsic information for "time" in decoder 2.
*******************************************************************************/
int Modify_Ge_Dec2(time)
int time;
{
 double sum,term;
 sum=Gamma_E_P2[time][ZERO]+Gamma_E_P2[time][ONE];
 Gamma_E_P2[time][ZERO]=Gamma_E_P2[time][ZERO]/sum;
 Gamma_E_P2[time][ONE]=Gamma_E_P2[time][ONE]/sum;
 if(Gamma_E_P2[time][ZERO] > Gamma_E_P2[time][ONE])
 {
  term= -2.0*VARIANCE*log(Gamma_E_P2[time][ZERO]);
  term=  sqrt(term)+2.0;
  term= -term*term*Inv_Twice_Noise_Var;
  Gamma_E_P2[time][ONE]=exp(term);
 }
 else
 {
  term= -2.0*VARIANCE*log(Gamma_E_P2[time][ONE]);
  term=  sqrt(term)-2.0;
  term= -term*term*Inv_Twice_Noise_Var;
  Gamma_E_P2[time][ZERO]=exp(term);
 }
 return(0);
}
/******************************************************************************/
