/******************************************************************************/
#include "tc7type.h"
#include "tc7ext.h"
/******************************************************************************/
/*      Get information about parity 1 and parity 2 when they dont exist.
*******************************************************************************/
int Get_Extrinsic_Info()
{
 Get_Parity1_Info();
 Get_Parity2_Info();
 return(0);
}
/******************************************************************************/
/*            Get information about parity 1 when it does exist.
*******************************************************************************/
int Get_Parity1_Info()
{
 int time;
 Init_Alpha_Beta_Dec1();
 Compute_Alpha_Beta_Dec1();
 for(time=ZERO;time<FRAME_SIZE;time++)
 {
  if((time%2) != P1_EXISTS)                             /* P1 does not exist. */
   Get_P1_Info(time);
 }
 return(0);
}
/******************************************************************************/
/*          Get information about parity 1 when it does not exist.
*******************************************************************************/
int Get_P1_Info(time)
int time;
{
 Get_E_Info_Dec1(time);
 Normalize_E_Info_Dec1(time);
 Get_P1_Error(time);
 return(0);
}
/******************************************************************************/
/*            Get information about parity 2 when it does exist.
*******************************************************************************/
int Get_Parity2_Info()
{
 return(0);
}
/******************************************************************************/
/*          Get information about parity 2 when it does not exist.
*******************************************************************************/
int Get_P2_Info(time)
int time;
{
 Get_E_Info_Dec2(time);
 Normalize_E_Info_Dec2(time);
 Get_P2_Error(time);
 return(0);
}
/******************************************************************************/
