/******************************************************************************/
#include "tc6type.h"
#include "tc6ext.h"
/******************************************************************************/
int Pre_Processor()
{
 Sim_Init();
 Get_BPSK_Map();
 Get_Iv_Map();
 Get_Enc_Taps();
 Get_Trellis();
 Ck_Var();
 return(0);
}
/******************************************************************************/
/*                           Get encoder 1 taps.
*******************************************************************************/
int Get_Enc_Taps()
{
 Get_Enc_Numer_Taps();
 Get_Enc_Denom_Taps();
 return(0);
}
/******************************************************************************/
/*                      Get encoder 1 numerator taps.
*******************************************************************************/
int Get_Enc_Numer_Taps()
{
 Enc_N[0]=1;
 Enc_N[1]=0;
 Enc_N[2]=1;
 Enc_N[3]=1;
 Enc_N[4]=1;
 return(0);
}
/******************************************************************************/
/*                      Get encoder 1 denominator taps.
*******************************************************************************/
int Get_Enc_Denom_Taps()
{
 Enc_D[0]=1;
 Enc_D[1]=1;
 Enc_D[2]=0;
 Enc_D[3]=0;
 Enc_D[4]=1;
 return(0);
}
/******************************************************************************/
