# Plot of the bit error rates for rate-1/2 (QPSK) turbo-codes for type 1
# channel.
set term postscript eps color 22
set nokey
set format y "%2.1e"
set output "chan1_err.eps"
set logscale y
#set xlabel "SNR (dB)"
#set ylabel "Symbol error rate"
plot "../tc4color/tc4cdata/tc4cawgn.dat" t "CID in AWGN"\
      w lines lt 1 lw 3,\
     "../tc5color/tc5cdata/tc5c_chan1.dat" t "LE+PID for channel 1"\
      w lines lt 3 lw 3,\
     "../tc6color/tc6cdata/tc6c_chan1.dat" t "LE+CID for channel 1"\
      w lines lt 4 lw 3
