# Plot of the bit error rates for rate-1/2 (QPSK) turbo-codes for type 2
# channel.
set term postscript eps color 22
set nokey
set format y "%2.1e"
set output "mux2_chan2_err.eps"
set logscale y
#set xlabel "SNR (dB)"
#set ylabel "Symbol error rate"
plot "../tc4color/tc4cdata/tc4cawgn.dat" t "CID in AWGN"\
      w lines lt 1 lw 3,\
     "../tc5color/tc5cdata/tc5c_chan2.dat" t "LE+PID for channel 1, MUX 1"\
      w lines lt 3 lw 3,\
     "../tc7color/tc7cdata/tc7c_chan2.dat"\
      t "LE+PID for channel 2, 32-states, MUX 2"\
      w lines lt 4 lw 3,\
     "../tc7color/tc7cdata/tc7c_chan2_p2.dat"\
      t "LE+PID for channel 2, 64-states, MUX 2"\
      w lines lt 8 lw 3,\
     "../tc6color/tc6cdata/tc6c_chan2.dat" t "LE+CID for channel 2"\
      w lines lt 7 lw 3
